// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "MovingSphereActor.generated.h"

UCLASS()
class PLUGINEXAMPLE_API AMovingSphereActor : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AMovingSphereActor();

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Awesome Category")
		bool AnimateMesh = true;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Awesome Category")
		float Frequency = 0.5f;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Awesome Category")
		float Amplitude = 100.f;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Awesome Category")
		float phase = PI / 4.f;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Awesome Category")
		UMaterialInterface* Material;

	UPROPERTY(VisibleAnywhere, BlueprintReadWrite, Category = "Awesome Category")
		float CurrentTime = 0.0f;

private:

	FVector origin;
	float ComputeSin();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

};
